/* NB: This file must be compiled by C, not C++! */
/* Provide a BSD-like gethostname() for those systems that lack it. */

#include <config.h>
#include <xerrno.h>

#if defined(HAVE_STRING_H)
#include <string.h>
#endif

#if defined(HAVE_SYS_UTSNAME_H)
#include <sys/utsname.h>
#endif

#include <xstdlib.h>

#if defined(__hppa)
#define LEN_TYPE	size_t
#else
#define LEN_TYPE	int
#endif

#if STDC
int
gethostname(char *name, LEN_TYPE len)
#else /* NOT STDC */
int
gethostname(name,len)	/* return 0 on success, -1 on failure (and set errno) */
char			*name;
LEN_TYPE		len;
#endif /* STDC */
{
    struct utsname	uts;

    if ((uname(&uts) == -1) || (name == (char*)NULL) ||
	(len < (1 + (int)strlen(uts.nodename))))
    {
	errno = EFAULT;
	return (-1);
    }
    strcpy(name,uts.nodename);
    return (0);
}
