#include <config.h>

#include <hash.h>

#define NBITS 5		/* shift count in hash function */

#if STDC
int
hash(const char *thename)
#else /* NOT STDC */
int
hash(thename)		/* return hash index of thename in 0..MAXHASH-1 */
const char *thename;
#endif /* STDC */
{
    register int h;
    register const char *p;

    for (h = 0, p = thename; *p; ++p)
	h = ((h << NBITS) ^ *p);
    if (h < 0)
	h = -h;
    if (h < 0)	/* in case of most negative two's complement integer */
	h = 0;
    return (h % MAXHASH);
}
