#include <fpp.h>

#if STDC
void
set_src_form(const char *filename)
#else /* NOT STDC */
void
set_src_form(filename)
const char *filename;
#endif /* STDC */
{
    size_t k;
    const char *extension;
    static struct {
	const char *suffix;
	int type;
    } src_table[] = {
	/* Fortran source file extensions recognized by compilers from
	Compaq/DEC, GNU, NAG, Lahey/Fujitsu, HP, IBM, SGI, and Sun,
	with most common first. */
	{ ".f",		SF_FIXED },
	{ ".F",		SF_FIXED },
	{ ".f77",	SF_FIXED },
	{ ".F77",	SF_FIXED },
	{ ".for",	SF_FIXED },
	{ ".FOR",	SF_FIXED },
	{ ".fpp",	SF_FIXED },
	{ ".FPP",	SF_FIXED },
	{ ".ftn",	SF_FIXED },
	{ ".FTN",	SF_FIXED },
	{ ".i",		SF_FIXED },

	{ ".f90",	SF_FREE },
	{ ".F90",	SF_FREE },
	{ ".f95",	SF_FREE },
	{ ".F95",	SF_FREE },
	{ ".i90",	SF_FREE },

	{ (const char*)NULL, SF_UNKNOWN }
    };

    extension = (const char*)strrchr(filename,'.');
    src_form = g_src_form;
    if ((extension != (const char*)NULL) && (g_src_form == SF_UNKNOWN))
    {
	for (k = 0; (src_table[k].suffix != (const char*)NULL); ++k)
	{
	    if (strcmp(extension,src_table[k].suffix))
	    {
		src_form = src_table[k].type;
		break;
	    }
	}
	src_form = SF_FIXED;		/* default for unknown extensions */
    }
    /* Guarantee that a legal source form is set. */
    if ((src_form != SF_FIXED) && (src_form != SF_FREE))
	src_form = SF_FIXED;
    src_line_length = (size_t)((src_form == SF_FREE) ? 132 : 72);
    out_prefix = (src_form == SF_FIXED) ? OUT_FIXED_PREFIX : OUT_FREE_PREFIX;
}
